(*
Author:  Christian Sternagel <c.sternagel@gmail.com> (2015)
Author:  René Thiemann <rene.thiemann@uibk.ac.at> (2014, 2015)
License: LGPL (see file COPYING.LESSER)
*)
theory Multiset_Code
imports 
  "~~/src/HOL/Library/DAList_Multiset" 
  Multiset2
begin

lemma [code]: "Union_mset (Bag ms) = DAList_Multiset.fold (\<lambda> a n. (op + a ^^ n)) 0 ms"
  unfolding Union_mset_def
  by (rule comp_fun_commute.DAList_Multiset_fold, unfold_locales, auto simp: ac_simps)

hide_const (open) DAList_Multiset.join

end
